JOIN(1)

NAME
join - relational database operator

SYNOPSIS
join [ options ] file1 file2

DESCRIPTION
Join forms, on the standard output, a join of the two relations specified by the lines of file1 and file2. If one of the file names is the standard input is used.

File1 and file2 must be sorted in increasing ASCII collating sequence on the fields on which they are to be joined, normally the first in each line.

There is one line in the output for each pair of lines in file1 and file2 that have identical join fields. The output line normally consists of the common field, then the rest of the line from file1, then the rest of the line from file2.

Input fields are normally separated spaces or tabs; output fields by space. In this case, multiple separators count as one, and leading separators are discarded.

The following options are recognized, with POSIX syntax.

-a n
    In addition to the normal output, produce a line for each unpairable line in file n, where n is 1 or 2.

-v n
    Like -a, omitting output for paired lines.

-e s
    Replace empty output fields by string s.

-1 m

-2 m
    Join on the mth field of file1 or file2.

-jn m
    Archaic equivalent for -n m.

-ofields
    Each output line comprises the designated fields. The comma-separated field designators are either 0, meaning the join field, or have the form n.m, where n is a file number and m is a field number. Archaic usage allows separate arguments for field designators.

-tc Use character c as the only separator (tab character) on input and output. Every appearance of c in a line is significant.

EXAMPLES

sort /etc/passwd | join -t: -1 1 -a 1 -e "" - bdays
    Add birthdays to the /etc/passwd file, leaving unknown birthdays empty. The layout of /adm/users is given in passwd(5); bdays contains sorted lines like

tr : ' ' </etc/passwd | sort -k 3 3 >temp

join -1 3 -2 3 -o 1.1,2.1 temp temp | awk '$1 < $2'
    Print all pairs of users with identical userids.

SOURCE
/usr/local/plan9/src/cmd/join.c

SEE ALSO
sort(1), comm(1), awk(1)

BUGS
With default field separation, the collating sequence is that of sort -b -ky,y; with -t, the sequence is that of sort -tx -ky,y.

One of the files must be randomly accessible.